//!<#@ template language="C#" #>
//!<#@ samplevars Processor="DirectiveProcessor" #>
//!<# if (!Params.ACL)  return string.Empty; #>
//!<# if (Params.Storage != StorageType.Ntfs)  return string.Empty; #>
using System;
using System.Collections.Generic;
using ITHit.WebDAV.Server;

namespace ITHit.WebDav.Server.SampleModel.__NtfsStorage__.Acl
{
    /// <summary>
    /// Logical folder right under webdav root with name 'acl' which
    /// contains folders 'users' and 'groups'.
    /// </summary>
    public class AclFolder : LogicalFolder
    {
        //!<# if (false) {#>
        //TODO: check read privilege in all property gets?
        //!<# } #>
        /// <summary>
        /// Initializes a new instance of the AclFolder class.
        /// </summary>
        /// <param name="context">Instace of <see cref="DavContext"/>.</param>
        public AclFolder(DavContext context) : base(context, "acl", "acl/")
        {
        }

        /// <summary>
        /// Retrieves children of /acl folder.
        /// We have here 'user' and 'group' folder for holding users and groups respectively.
        /// </summary>
        /// <param name="propNames">Property names to be fetched lated.</param>
        /// <returns>Children of this folder.</returns>
        public override IEnumerable<IHierarchyItem> GetChildren(IList<PropertyName> propNames)
        {
            yield return new UserFolder(Context);
            yield return new GroupFolder(Context);
        }
    }
}
