﻿//!<#@ template language="C#" #>
//!<#@ samplevars Processor="DirectiveProcessor" #>
//!<# if (!Params.CalDav)  return string.Empty; #>
using System;
using System.Collections.Generic;
using System.DirectoryServices.AccountManagement;
using System.IO;
using System.Linq;
using System.Web;

using ITHit.WebDAV.Server;
using ITHit.WebDAV.Server.CalDav;
using ITHit.WebDAV.Server.Acl;

namespace ITHit.WebDav.Server.SampleModel.__NtfsStorage__.CalDav
{
    public class CalUserFolder : DavFolder, ICalendarFolderContainer
    {
        public static string PREFIX = "calendars/users/";
        
        public CalUserFolder(DirectoryInfo dirInfo, DavContext context, string path)
            : base(dirInfo, context, path)
        {
        }

        public override IEnumerable<IHierarchyItem> GetChildren(IList<PropertyName> propNames)
        {
            var path = System.IO.Path.Combine(context.RepositoryPath, "calendars");
            path = System.IO.Path.Combine(path, Name);

            var dirs = context.FileOperation(this, () => new System.IO.DirectoryInfo(path).GetDirectories(), Privilege.Read);
            
            foreach (var f in dirs)
            {
                yield return new CalFolder(context, Name, f.Name);
            }            
        }

        public ICalendarFolder CreateCalendarFolder(string name)
        {
            var path = System.IO.Path.Combine(context.RepositoryPath, "calendars");
            path = System.IO.Path.Combine(path, Name);
            path = System.IO.Path.Combine(path, name);
            context.FileOperation(this, ()=>System.IO.Directory.CreateDirectory(path), Privilege.Bind);
            return new CalFolder(context, Name, name);
        }
    }
}
