﻿//!<#@ template language="C#" #>
//!<#@ samplevars Processor="DirectiveProcessor" #>
//!<# if (!Params.CalDav)  return string.Empty; #>
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

using ITHit.WebDAV.Server;
using System.DirectoryServices.AccountManagement;
using ITHit.WebDAV.Server.Acl;

namespace ITHit.WebDav.Server.SampleModel.__NtfsStorage__.CalDav
{
    public class UidsFolder : LogicalFolder
    {
        public static string PREFIX = "calendars/users";
        public static string PATH
        {
            get { return PREFIX + "/"; }
        }

        public UidsFolder(DavContext context)
            : base(context, "users", PATH)
        {
        }

        public override IEnumerable<IHierarchyItem> GetChildren(IList<PropertyName> propNames)
        {
            var path = System.IO.Path.Combine(Context.RepositoryPath, "calendars");
            var dirs = Context.FileOperation(this, () => new System.IO.DirectoryInfo(path).GetDirectories(), Privilege.Read);

            foreach (var f in dirs)
            {
                yield return new CalUserFolder(f, Context, "calendars/users/" + EncodeUtil.EncodeUrlPart(f.Name) +"/");
            }                        
        }
    }
}
