//!<#@ template language="C#" #>
//!<#@ samplevars Processor="DirectiveProcessor" #>
//!<# if (!Params.ACL && !Params.CalDav)  return string.Empty; #>
//!<# if (Params.Storage != StorageType.Ntfs)  return string.Empty; #>
using System;
using System.Collections.Generic;
using ITHit.WebDAV.Server;

namespace ITHit.WebDav.Server.SampleModel.__NtfsStorage__
{
    /// <summary>
    /// Base class for logical folders which are not present in file system, like '/acl/,
    /// '/acl/groups/'
    /// </summary>
    public abstract class LogicalFolder : IItemCollection
    {
        public DavContext Context { get; private set; }

        public string Name { get; private set; }

        public string Path { get; private set; }

        protected LogicalFolder(DavContext context, string name, string path)
        {
            Context = context;
            Name = name;
            Path = path;
        }

        public DateTime Created
        {
            get { return DateTime.UtcNow; }
        }

        public DateTime Modified
        {
            get { return DateTime.UtcNow; }
        }

        public void CopyTo(IItemCollection destFolder, string destName, bool deep, MultistatusException multistatus)
        {
            throw new NotImplementedException();
        }

        public void MoveTo(IItemCollection destFolder, string destName, MultistatusException multistatus)
        {
            throw new NotImplementedException();
        }

        public void Delete(MultistatusException multistatus)
        {
            throw new NotImplementedException();
        }

        public IEnumerable<PropertyValue> GetProperties(IList<PropertyName> props, bool allprop)
        {
            return new PropertyValue[0];
        }

        public IEnumerable<PropertyName> GetPropertyNames()
        {
            return new PropertyName[0];
        }

        public void UpdateProperties(IList<PropertyValue> setProps, IList<PropertyName> delProps, MultistatusException multistatus)
        {
            throw new NotImplementedException();
        }

        public abstract IEnumerable<IHierarchyItem> GetChildren(IList<PropertyName> propNames);
    }
}
